package strategy;

import java.util.Random;

import game.Game;

public class ModifiedConstant extends UtilityBasedStrategy {
	int constantAction;
	int badCount=0;
	int goodCount=0;
	int badCutoff = 3;
	int goodCutoff = 5;
	int badThresh = 8;
	int goodThresh = 8;
	public ModifiedConstant(Game g, long seed, String options) {
		super(g, seed);
	    int numActions = g.getNumActions();
	    Random r = new Random(seed);
	    constantAction = r.nextInt(numActions);
	}

	@Override
	public void observeUtilities(int[] possibleUtilities, int currentAction) {
		if(possibleUtilities[constantAction]<badThresh){
			badCount++;
		} else if (possibleUtilities[constantAction]>goodThresh) {
			goodCount++;
		}
		if(goodCount > goodCutoff){
			badCount=0;
		}
		if(badCount > badCutoff){
			constantAction = r.nextInt(numActions);
			badCount=0;
		}
	}

	@Override
	public int getAction() {
		// TODO Auto-generated method stub
		return constantAction;
	}

}
