package brownstrategy;

import java.util.Random;
import java.util.Stack;

import brownstrategy.agent.Agent;
import brownstrategy.agent.DeterministicAgent;
import brownstrategy.agent.NondeterministicAgent;

import game.Game;
import game.Strategy;

public class QuarterRandom extends NondeterministicAgent {
	
	int turn = 0;
	Random rand = new Random();
	int lastmove = rand.nextInt(12);
	int delta = rand.nextInt(12);
	Stack<Integer> turns;

	public QuarterRandom(Game g, long seed, String options) {
		super(g,seed,options);
		turns = new Stack<Integer>();
	}
	
	@Override
	public Agent getCopy() {
		return new QuarterRandom(_g, _seed, _options);
	}

	@Override
	public Agent getCopy(Game g, long seed, String options) {
		return new QuarterRandom(g, seed, options);
	}

	@Override
	public double[] getActionDistribution() {
		if(_day == _cacheDay) {
			return _cacheDist;
		}
		_cacheDist = new double[12];
		_cacheDay = _day;
		lastmove = (lastmove+delta)%12;
		turn++;
		if(turn>25){
			turn=0;
			delta=rand.nextInt(12);
		}
		_cacheDist[lastmove] = 1;
		return _cacheDist;
	}

	@Override
	public void observeOutcome(int[] actions) {
		_day++;
	}
	
	@Override
	public void lookAhead(int[] actions) {
		turns.push(turn);
		observeOutcome(actions);
	}

	@Override
	public void lookBack() {
		turn = turns.pop();
		_day--;
	}

}
