package brownstrategy.oracles;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;

/**
 *
 * This class smooths distributions by
 * adding N to every index and then normalizing
 * @author jberg
 *
 */

public class PlusNSmoothing {


	public static double[] PlusNSmoothing(int[] arr, double n) {
		double[] newArr = new double[arr.length];
		for(int i = 0; i < arr.length; i++) {
			newArr[i] = arr[i] + n;
		}
		return normalize(newArr);
	}
	
	/**
	 * Normalizes a distribution so that it sums to 1.
	 * @param distribution
	 * @return
	 */
	public static double[] normalize(double[] distribution) {
		double[] normDistribution = new double[distribution.length];
		double sum = 0;
		for (int i=0; i<distribution.length; i++) {
			sum += distribution[i];
		}

		/*
		 * added handling for sum is zero.  this shouldn't ever
		 * happen, but if it does it returns a unifrom distribution
		 * 
		 * -jberg
		 */
		if(sum == 0) {
			double uniform = 1.0/distribution.length;;
			for (int i=0; i<distribution.length; i++) {
				normDistribution[i] = uniform;
			}
		}
		else {
			for (int i=0; i<distribution.length; i++) {
				normDistribution[i] = distribution[i] / sum;
			}
		}
		return normDistribution;
	}

}