package  edu.cmu.psy.reitter.meta;

import java.lang.String;
import java.util.StringTokenizer;

public class LM  // Linear Model
{

    int[][] contrast_matrix;
    float[] coeff;

    int num_coeff= 0;

    String covnames[];

    public LM (String rmodel, String factor_filter, String covariates)
    {
	// parse rmodel as output from R:  summary(m)

	coeff = new float[1000];
	contrast_matrix = new int[1000][100];

	covnames = covariates.split("\\s+");

	StringTokenizer st = new StringTokenizer(rmodel, "\n");

	while (st.hasMoreTokens()) {
	    
	    StringTokenizer cst = new StringTokenizer(st.nextToken());  // split each line

	    if (st.countTokens() >= 5)
		{
		    String covn[] = cst.nextToken().split(":");
		    
		    if (factor_filter.equals("") || covn[0].equals(factor_filter))
			{
			   
			    String s = cst.nextToken();
			    
			    if (s.equals("NA"))
				break;

			    coeff[num_coeff] = Float.parseFloat(s.toUpperCase());
			   
			    // awkward, but whatever

			    for (int c=0; c<covn.length; c++)
				{
				    int covindex = indexOfCovariate(covn[c]);
				    
				    if (covindex>=0)
					{
					    contrast_matrix[num_coeff][covindex] = 1;
					}
				}

		    
			    num_coeff++;
			}
		}
	}
    }

    public int indexOfCovariate (String covname)
    {
	// find index assigned to this covariate  - hack
	int covindex = -1;
	for (int z=0; z<covnames.length; z++)
		if (covnames[z].equals(covname))
			return z;
	return -1;
    }

    public float predict (float[] parameters)
    {
	float outcome = 0;
	for(int i=0; i<num_coeff; i++)
	    {
		int sum = 0;
		for (int j=0; j<parameters.length; j++)
		    {
			// System.out.format("%d %f\n", contrast_matrix[i][j] , parameters[j]);
			outcome += contrast_matrix[i][j] * parameters[j] * coeff[i];
			sum += contrast_matrix[i][j];
		    }
		if (sum==0) // intercept?
		    outcome += coeff[i];
	    }
	return outcome;
    }

}