package analysis;

public class Unsolvable implements GameSet{

  


  /**
   * If one of eqA and two of eqB are an equilibrium.
   * @param eqA
   * @param eqB
   * @param allEq
   * @return
   */
  public boolean areExchangeable(int[] eqA, int[] eqB, boolean[][][] allEq){
    if (!allEq[eqA[0]][eqB[1]][eqB[2]]){
      return false;
    }
    if (!allEq[eqB[0]][eqA[1]][eqB[2]]){
      return false;
    }
    if (!allEq[eqB[0]][eqB[1]][eqA[2]]){
      return false;
    }
    
    return true;
  }
  
  @Override
  public boolean contains(ThreePlayerGame g) {
    int[] actions = g.getNumActions();
    
    // By default, this is false
    boolean[][][] eqFlags = new boolean[actions[0]][actions[1]][actions[2]];
    
    
    int[][] equilibria = g.getPureEquilibria();
    for(int[] eq:equilibria){
      eqFlags[eq[0]][eq[1]][eq[2]]=true;
    }
    
    for(int[] eq:equilibria){
      for(int[] eqB:equilibria){
        if (!areExchangeable(eq,eqB,eqFlags)){
          return true;
        }
      }
    }
    return false;
    
  }
  
}
