package lemonade;

import game.Game;
import game.GameGenerator;

import java.util.Random;


public class GeneralizedLemonadeGameGenerator implements GameGenerator{
  Random r;
  long seed;
  long queries;
  public GeneralizedLemonadeGameGenerator(long seed){
    r = new Random(seed);
  }
  @Override
  public Game getNextGame() {
    queries++;
    final int numActions = 12;
    int[] islandDensity = new int[numActions];
    for(int i=0;i<islandDensity.length;i++){
      islandDensity[i]=(r.nextInt(3)+1)*6;
    }
    Game g = new Game(new int[]{numActions, numActions, numActions},new GeneralizedLemonadeUtility(islandDensity));
    return g;
  }
  
  public GeneralizedLemonadeGameGenerator clone(){
    GeneralizedLemonadeGameGenerator copy = new GeneralizedLemonadeGameGenerator(seed);
    for(long query=0;query<queries;query++){
      copy.getNextGame();
    }
    return copy;
  }
  
}
