package lemonade;
import game.Utility;

import java.util.Arrays;
import java.util.Vector;

/**
 * A class for calculating utilities.
 * To calculate the utility of a player, there 
 * @author maz
 *
 */
public class GeneralizedLemonadeUtility extends AbstractLocationGameUtility{
  /**
   * The size of the island: also the number of actions.
   */
  private int islandSize;
  
  private int[] islandDensity;
  
  
  
  /**
   * Create a utility function for an island of a certain size.
   * @param islandSize the size of the island (number of actions)
   */
  public GeneralizedLemonadeUtility(int[] islandDensity){
    super(islandDensity.length);
    this.islandSize = islandDensity.length;
    this.islandDensity = islandDensity;
  }
  
  public int[] getIslandDensity(){
    int[] result = new int[islandDensity.length];
    System.arraycopy(islandDensity,0,result,0,islandDensity.length);
    return result;
  }
  
  
  public int getNumConsumers(int position){
    return islandDensity[position];
    
  }
  /**
   * Get the size of the island (number of actions)
   * @return the size of the island (number of actions)
   */
  public int getIslandSize(){
    return islandSize;
  }
  
  public int getDistance(int posA, int posB){
    if (posA<posB){
      return getDistance(posB,posA);
    }
    int basicDistance = posA-posB;
    int loopDistance = posB+islandSize-posA;
    return Math.min(basicDistance, loopDistance);
  }
}
