package results;
import java.io.PrintStream;
import java.util.Vector;


public class CrossTable {
  long[][][] data;
  String principal;
  String[] names;
  
  
  public int getNameIndex(String name){
    for(int index=0;index<names.length;index++){
      if (names[index].equals(name)){
        return index;
      }
    }
    return -1;
  }
  public CrossTable(String principal, String[] names, Vector<TripleResults> results){
    this.principal = principal;
    this.names = new String[names.length];
    for(int i=0;i<names.length;i++){
      this.names[i]=names[i];
    }
    data = new long[names.length][names.length][3];
    for(TripleResults result:results){
      int principalIndex = result.getIndex(principal);
      int firstIndex = 1;
      int secondIndex = 2;
      if (principalIndex==-1){
        continue;
      } else if (principalIndex==0){
        
      } else if (principalIndex==1){
        firstIndex = 0;
        secondIndex = 2;
      } else {
        // principalIndex == 2
        firstIndex = 0;
        secondIndex = 1;
      }
      String firstName = result.playerNames[firstIndex];
      String secondName = result.playerNames[secondIndex];
      long firstScore = result.scores[firstIndex];
      long secondScore = result.scores[secondIndex];
      long principalScore = result.scores[principalIndex];
      int firstNameIndex = getNameIndex(firstName);
      int secondNameIndex = getNameIndex(secondName);
      if (firstNameIndex==-1 || secondNameIndex==-1){
        continue;
      }
      data[firstNameIndex][secondNameIndex][0]+=principalScore;
      data[firstNameIndex][secondNameIndex][1]+=firstScore;
      data[firstNameIndex][secondNameIndex][2]+=secondScore;
      data[secondNameIndex][firstNameIndex][0]+=principalScore;
      data[secondNameIndex][firstNameIndex][1]+=secondScore;
      data[secondNameIndex][firstNameIndex][2]+=firstScore;
      
    }
  }
  
  public static double scale=10000.0;
  public static String getValue(long original){
    double value = (double)original/scale;
    return String.format("%2.4g", value-8.0);
  }
  public void display(PrintStream stream){
    stream.print("This is an exhaustive list of all triple results including the principal player, "+this.principal+".<BR>");
    stream.print("Numbers are points per round - 8<BR>");
    stream.print("Order is principal player,row player, column player<BR>");
    stream.print("<TABLE><TR><TD>"+principal+"</TD>");
    for(String name:names){
      stream.print("<TD>"+name+"</TD>");
    }
    stream.println("</TR>");
    for(int i=0;i<names.length;i++){
      stream.print("<TR><TD>"+names[i]+"</TD>");
      for(int j=0;j<names.length;j++){
        if (i==j){
          stream.print("<TD></TD>");
        } else {
          stream.print("<TD>"+getValue(data[i][j][0])+","+getValue(data[i][j][1])+","+getValue(data[i][j][2])+"</TD>");
        }
      }
      stream.println("</TR>");
    }
  }
  
}
