package lemonade;

import static org.junit.Assert.*;

import java.util.Arrays;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import util.Array;

public class GeneralizedLemonadeUtilityTest {
  GeneralizedLemonadeUtility utility;
  @Before
  public void setUp() throws Exception {
    int[] islandDensity = new int[12];
    for(int i=0;i<islandDensity.length;i++){
      islandDensity[i]=6;
    }
    utility = new GeneralizedLemonadeUtility(islandDensity);
  }

  @After
  public void tearDown() throws Exception {
    utility = null;
  }

  @Test
  public void testGeneralizedLemonadeUtility() {
    assertNotNull(utility);
  }

  @Test
  public void testGetIslandDensity() {
    int[] islandDensity = utility.getIslandDensity();
    String representation = Arrays.toString(islandDensity);
    assertEquals("[6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6]",representation);
  }

  @Test
  public void testGetNumConsumers() {
    int consumers = utility.getNumConsumers(3);
    assertEquals(6,consumers);
  }

  @Test
  public void testGetIslandSize() {
    int islandSize = utility.getIslandSize();
    assertEquals(12,islandSize);
  }

  @Test
  public void testGetDistance() {
    int distance = utility.getDistance(3,5);
    assertEquals(2,distance);
  }

  @Test
  public void testGetDistance2() {
    int distance = utility.getDistance(10,11);
    assertEquals(1,distance);
  }

  @Test
  public void testGetDistance3() {
    int distance = utility.getDistance(11,0);
    assertEquals(1,distance);
  }

  @Test
  public void testGetDistance4() {
    int distance = utility.getDistance(9,3);
    assertEquals(6,distance);
  }

  @Test
  public void testGetUtility() {
    int[] utils= utility.getUtility(new int[]{3,3,3});
    assertEquals(24,utils[0]);
    
  }

  @Test
  public void testGetUtility2() {
    int[] utils= utility.getUtility(new int[]{3,3,3});
    assertEquals(24,utils[1]);
  }

  
  

}
