package stats.collusion;

import static org.junit.Assert.*;
import game.Game;
import lemonade.ScaledLemonadeUtility;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class SimpleCollusionObserverTest {
  SimpleCollusionObserver observer;
  @Before
  public void setUp() throws Exception {
    Game g = new Game(new int[]{12,12,12},new ScaledLemonadeUtility(12));
    observer = new SimpleCollusionObserver(g);
  }

  @After
  public void tearDown() throws Exception {
  }


  @Test
  public void testModuloArithmetic() {
    int result = (6 + 6) % 12;
    assertEquals(0,result);

  }


  @Test
  public void testModuloArithmeticB() {
    int result = 6 + 6 % 12;
    assertEquals(12,result);

  }

  
  @Test
  public void testIsInCollusion() {
    
    boolean resultA = observer.isInCollusion(0,6);
    boolean resultB = observer.isInCollusion(6,0);
    assertTrue(resultA);
    assertTrue(resultB);
    

  }

  @Test
  public void testTestCollusion() {
    int[] collusionActionsA=new int[]{0,6,9};
    int[] collusionActionsB=new int[]{6,0,9};
    
    boolean resultA = observer.testCollusion(collusionActionsA);
    boolean resultB = observer.testCollusion(collusionActionsB);
    assertTrue(resultA);
    assertTrue(resultB);
  }

  @Test
  public void testSimpleCollusionObserver() {
    fail("Not yet implemented");
  }

  @Test
  public void testObserveOutcome() {
    fail("Not yet implemented");
  }

  @Test
  public void testFinishGame() {
    fail("Not yet implemented");
  }

  @Test
  public void testFinishSeries() {
    fail("Not yet implemented");
  }

  @Test
  public void testDisplay() {
    fail("Not yet implemented");
  }

}
