/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.ualberta.rggibson;

/**
 *
 * @author Richard
 */
public class BehaviourAcross extends BehaviourModel
{
    int player;
    int target;
    int numActions;

    int[] nextAction;

    public BehaviourAcross(int numActions, int player, int target)
    {
        super();

        this.numActions = numActions;
        this.player = player;
        this.target = target;

        nextAction = null;
    }

    public String getName()
    {
        String name = "Across";
        if (target == -1)
        {
            name += "Avg";
        }
        else if (target == 0)
        {
            name += "Me";
        }
        else
        {
            name += "Opp";
        }

        return name;
    }

    public int[] getActionList()
    {
        assert (isAvailable());
        return nextAction;
    }

    public boolean isAvailable()
    {
        return (nextAction == null ? false : true);
    }

    public void update(int[] actions, boolean doUpdateCounts)
    {
        // Update the counts and weight
        if (doUpdateCounts && isAvailable())
        {
            count *= DECAY;
            maxCount *= DECAY;

            for (int a : nextAction)
            {
                if (actions[player] == a)
                {
                    count += 1.0;
                    break;
                }
            }
            maxCount += 1.0;

            weight = count / maxCount;
        }

        // Update the next action
        if (target == -1)
        {
            // Sitting across from the average of the two other locations
            int otherOpp = (player == 1 ? 2 : 1);
            int diff = Math.abs(actions[0] - actions[otherOpp]);
            int smallerLoc = ((actions[0] <= actions[otherOpp]) ? actions[0] : actions[otherOpp]);
            int acrossAction = smallerLoc + (diff / 2);
            if (diff < (numActions / 2))
            {
                acrossAction += (numActions / 2);
            }

            if (diff == (numActions / 2))
            {
                // You cannot sit across from the average when the other two
                // players are sitting across from each other
                nextAction = null;
            }
            else if (UctBehaviourModeller.mod(diff, 2) == 1)
            {
                nextAction = new int[2];
                nextAction[0] = UctBehaviourModeller.mod(acrossAction, numActions);
                nextAction[1] = UctBehaviourModeller.mod(acrossAction + 1, numActions);
            }
            else
            {
                nextAction = new int[1];
                nextAction[0] = UctBehaviourModeller.mod(acrossAction, numActions);
            }
        }
        else
        {
            // Sitting across from the target
            nextAction = new int[1];
            nextAction[0] = UctBehaviourModeller.mod(actions[target] + (numActions / 2), numActions);
        }
    }

    public BehaviourModel clone()
    {
        BehaviourAcross bm = new BehaviourAcross(numActions, player, target);

        bm.count = count;
        bm.maxCount = maxCount;
        bm.weight = weight;
        if (nextAction != null)
        {
            bm.nextAction = new int[nextAction.length];
            for (int a = 0; a < nextAction.length; ++a)
            {
                bm.nextAction[a] = nextAction[a];
            }
        }

        return bm;
    }
}
