/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.ualberta.rggibson;
import game.Utility;

import java.util.ArrayList;

/**
 *
 * @author Richard
 */
public class BehaviourBestOverall extends BehaviourModel
{
    int player;
    int numActions;
    Utility util;

    int[] actionValues;
    int[] nextAction;

    public BehaviourBestOverall(int numActions, int player, Utility util)
    {
        super();

        this.numActions = numActions;
        this.player = player;
        this.util = util;

        actionValues = new int[numActions];
        nextAction = null;
    }

    public String getName()
    {
        return "BestOverall";
    }

    public int[] getActionList()
    {
        assert (isAvailable());
        return nextAction;
    }

    public boolean isAvailable()
    {
        return (nextAction == null ? false : true);
    }

    public void update(int[] actions, boolean doUpdateCounts)
    {
        // Update the counts and weight
        if (doUpdateCounts && isAvailable())
        {
            count *= DECAY;
            maxCount *= DECAY;

            for (int a : nextAction)
            {
                if (actions[player] == a)
                {
                    count += 1;
                    break;
                }
            }
            maxCount += 1;

            weight = count / maxCount;
        }

        // Update the values of each action
        int[] tempActions = { actions[0], actions[1], actions[2] };
        for (int a = 0; a < numActions; ++a)
        {
            tempActions[player] = a;
            actionValues[a] += util.getUtility(tempActions)[player];
        }

        // Find the best actions
        int bestValue = Integer.MIN_VALUE;
        ArrayList<Integer> bestActions = new ArrayList<Integer>();
        for (int a = 0; a < numActions; ++a)
        {
            if (actionValues[a] > bestValue)
            {
                bestActions.clear();
                bestActions.add(a);
                bestValue = actionValues[a];
            }
            else if (actionValues[a] == bestValue)
            {
                bestActions.add(a);
            }
        }

        nextAction = new int[bestActions.size()];
        for (int i = 0; i < nextAction.length; ++i)
        {
            nextAction[i] = bestActions.get(i);
        }
    }

    public BehaviourModel clone()
    {
        BehaviourBestOverall bm = new BehaviourBestOverall(numActions, player, util);

        bm.count = count;
        bm.maxCount = maxCount;
        bm.weight = weight;
        bm.nextAction = new int[nextAction.length];
        for (int a = 0; a < nextAction.length; ++a)
        {
            bm.nextAction[a] = nextAction[a];
        }
        bm.actionValues = new int[actionValues.length];
        for (int a = 0; a < actionValues.length; ++a)
        {
            bm.actionValues[a] = actionValues[a];
        }

        return bm;
    }
}
